﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;

namespace SmellsLikeFunctionalProgramming {
  class Program {
    static void Main(string[] args) {
      foreach (MemberInfo memberInfo in GetAllMembers()) {
        Console.WriteLine(memberInfo.Name);
      }
    }

    public static List<MemberInfo> GetAllMembers( ) {
      Assembly[] assemblies = AppDomain.CurrentDomain.GetAssemblies( );
      List<Type> types = new List<Type>( );

      foreach (Assembly assembly in assemblies) 
        types.AddRange(assembly.GetTypes( ));
      
      List<MemberInfo> members = new List<MemberInfo>( );

      foreach (Type type in types)
        members.AddRange(type.GetMembers( ));

      return members;
    }




















    public static List<MemberInfo> GetAllMembersFunctional( ) {
      List<MemberInfo> members = new List<MemberInfo>( );

      Array.ForEach(AppDomain.CurrentDomain.GetAssemblies( ), 
        delegate(Assembly assembly) {
          Array.ForEach(assembly.GetTypes( ), delegate(Type type) {
            members.AddRange(type.GetMembers( ));
          });
        });

      return members;
    }
























		// This implementation uses SelectMany with lambdas to do the work

		//public static IEnumerable<MemberInfo> GetAllMembersFunctional( ) {
		//	return AppDomain.CurrentDomain.GetAssemblies( ).SelectMany(
		//		assembly => assembly.GetTypes( ).SelectMany(
		//				type => type.GetMembers( )));
		//}

  }
}
